
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"


TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
   char buff[60];
   TRegKeyInfo Value ; AnsiString KeyData;
   TRegistry *Reg = new TRegistry;
   NewConfigData = false;
 UpDown1->Max = BIGGESTGAMES;  UpDown2->Max = BIGGESTDRAWS;
 //  try
 // {
    Reg->RootKey = HKEY_CURRENT_USER;
 if (Reg->OpenKey("\\Software\\Resp_Tech\\MHLotto", false))
 {
    if (Reg->GetKeyInfo(Value))
    if (Value.NumValues == 2) // check if setup data is OK and also music
 {      KeyData = Reg->ReadString("MHLotto");
  if (sscanf(KeyData.c_str(), "%d %d %d %d %d %s\n", &xgames, &xdraws, &xrange, &xindep, &xsupp, buff) == PARMNUM)
   {  SpinDate = AnsiString(buff); NewConfigData = true;
   MusicFN = Reg->ReadString("MHmusic");
     // KeyData = Reg->ReadString("MHmusic");
     // strcpy(musicfn, KeyData.c_str());
 if (access(MusicFN.c_str(), 04) == 0)  // exists and readable
 {
 MediaPlayer1->Enabled = True; MediaPlayer1->Visible = True;
 MediaPlayer1->FileName = MusicFN.c_str();  MediaPlayer1->Open();
 Label5->Caption = MusicFN;
 }}
 }}
    Reg->CloseKey();
    delete Reg;
    if (!NewConfigData) // something wrong with registry, use defaults instead
    { xgames = 1; xdraws = 1; xrange = 1; xindep = 1; xsupp = 0; NewConfigData = true;
    }
  }
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Print1Click(TObject *Sender)
{
  Print();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MakeGrid(TObject *Sender)
{
  int i, j = 0;  char buff[20];
  if (NewConfigData) // take the configuration from registry or file
    {   Edit1->Text = itoa(xgames,buff,10);
        Edit2->Text = itoa(xdraws,buff,10);
        Edit3->Text = itoa(xrange,buff,10);
        Edit4->Text = itoa(xindep,buff,10);
        Edit5->Text = itoa(xsupp,buff,10);
        NewConfigData = false;
    }

            Form1->Caption = AnsiString("MHLotto     [") + GameName
         + AnsiString("]    Random Number Selector for Unimaginative Players");

  StringGrid1->ColCount=1+xdraws;
  StringGrid1->RowCount=1+xgames;
  StringGrid1->Cells[0][0] = SpinDate ;
  for (i = 0; i < (1+StringGrid1->RowCount); i++)
      StringGrid1->Cells[0][i+1] = AnsiString("Game ") + (i+1);
  for (i = 1; i < (1+xdraws-xindep); i++)
      StringGrid1->Cells[i][0] = AnsiString("Draw ") + i;
  for (; i < (1+xdraws); i++)
  { j++ ;  StringGrid1->Cells[i][0] = AnsiString("Indep ") + j;
  }
  for (j = 1; j < (1+StringGrid1->ColCount); j++)
  for (i = 1; i < (1+StringGrid1->RowCount); i++)
 { if (lotto[j-1][i-1])
   StringGrid1->Cells[j][i] = lotto[j-1][i-1];
   else
   StringGrid1->Cells[j][i] = AnsiString("_________");
 }
 }
 //---------------------------------------------------------------------------

void __fastcall TForm1::PrinterSetup1Click(TObject *Sender)
{
  PrinterSetupDialog1->Execute();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit1Change(TObject *Sender)
{
  if (!NewConfigData) xgames = atoi(Edit1->Text.c_str());
   TForm1::TidyUp(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit2Change(TObject *Sender)
{
     if (!NewConfigData)
  {
    xdraws = atoi(Edit2->Text.c_str());
    EditAllCheck(Sender);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit3Change(TObject *Sender)
{
      if (!NewConfigData)
   {    xrange = atoi(Edit3->Text.c_str());
        EditAllCheck(Sender); //      TForm1::TidyUp(Sender);
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit4Change(TObject *Sender)
{
   if (!NewConfigData)
   {
      xindep = atoi(Edit4->Text.c_str());
      EditAllCheck(Sender);
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit5Change(TObject *Sender)
{   if (!NewConfigData)
   {
      xsupp = atoi(Edit5->Text.c_str());
      EditAllCheck(Sender);
   }
}
//---------------------------------------------------------------------------


 void __fastcall TForm1::EditAllCheck(TObject *Sender)
{    char buff[20];
   if (xindep > xdraws - 1)
   { xindep = xdraws - 1;
     Edit4->Text = itoa(xindep,buff,10);
   }
 //   if (xsupp > (xdraws-xindep))
 //  { xsupp = xdraws-xindep;
 //    Edit5->Text = itoa(xsupp,buff,10);
 //  }
    GameName = "";  PowerBall1->Checked = false; Tattslotto1->Checked = false;
    TForm1::TidyUp(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::OpenLotClick(TObject *Sender)
{
FILE *infile;   char buff[100];

 if (OpenDialog2->Execute());
 {
  infile = fopen(OpenDialog2->FileName.c_str(), "rt");
  if (infile)
  {
  PathName =  OpenDialog2->FileName;
  if (fscanf(infile, "%d %d %d %d %d %s\n",
    &xgames, &xdraws, &xrange, &xindep, &xsupp, buff) == PARMNUM)
   {  SpinDate = AnsiString(buff); GameName = ""; NewConfigData = true;
   }
   for (int row = 0; row < xgames; row++)
   {for (int col = 0; col < xdraws; col++)
   fscanf(infile, "%d ", &lotto[col][row]);
  }
  fclose(infile);
  PowerBall1->Checked = false; Tattslotto1->Checked = false;
  TForm1::MakeGrid(Sender);
  }
 }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Spin1Click(TObject *Sender)
{
   int col, row, i, j, dest, selection; BOOL dup;

 /* Seed the random-number generator with time */
    Randomize();
   for (row = 0; row < xgames; row++)
  { for(col = 0; col < (xdraws-xindep); col++) // draw from barrel 1
   { j = 0;
    do
    { dup = 0; dest = 0; j++; // limit this search for unique random number
  selection = 1 + (int) (rand() % xrange);  // get rid of any 0 and make the max value possible

  for (i = 0; i < col; i++)
      { if (lotto[i][row] == selection) dup = 1; // duplicate found, do it again
        if (lotto[i][row] < selection) dest = i + 1; // get first suitable storage location
      }
    } while (dup && (j < 100)); // keep trying for a unique number i.e recycle for dupl up to 10
     for (i = BIGGESTDRAWS-1; i > dest; i--) lotto[i][row] = lotto[i-1][row]; // move up to make space
    lotto[dest][row] = selection; // put the random number in the array
   }
   for(; col < xdraws; col++) // do the independent draws if any
    { selection = 1 + (int) (rand() % xrange);
      lotto[col][row] = selection; // put the random number in the array
    }
  }
   SpinDate = DateToStr(Date());
   TForm1::MakeGrid(Sender); // display new numbers
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Save1Click(TObject *Sender)
{
  if (StrLen(PathName.c_str()))
  {
          FILE *outfile = fopen(PathName.c_str(), "wt");
          if (outfile)  SaveLotto(outfile);
  }
  else   TForm1::SaveAs1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SaveAs1Click(TObject *Sender)
{
FILE *outfile;
  if (StrLen(PathName.c_str()))
       SaveDialog1->FileName = PathName;
 // else SaveDialog1->FileName = "*.lot";
 //SaveDialog1->Filter = "Lotto files (*.lot)|*.lot|All files (*.*)|*.*";
 //SaveDialog1->FilterIndex = 1; // start the dialog showing lotto files
 //SaveDialog1->Title = "Save lotto numbers and parameters";

 if (SaveDialog1->Execute())
 {
  outfile = fopen(SaveDialog1->FileName.c_str(), "wt");
  if (outfile)
  {
   PathName =  SaveDialog1->FileName;
   SaveLotto(outfile);
  }}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SaveLotto(FILE *outfile)
{
  char buff[60];
   TRegistry *Reg = new TRegistry;
   sprintf(buff, "%d %d %d %d %d %s", xgames, xdraws, xrange, xindep, xsupp, SpinDate.c_str());
   fprintf(outfile,"%s\n",buff);
   for (int row = 0; row < xgames; row++)
  {for (int col = 0; col < xdraws; col++) fprintf(outfile, "%d ", lotto[col][row]);
   fprintf(outfile,"\n");
  }
  fclose(outfile);

    Reg->RootKey = HKEY_CURRENT_USER;
 if (Reg->OpenKey("\\Software\\Resp_Tech\\MHLotto", true))
 {
    //  if (Reg->GetKeyInfo(Value))
    //if (Value.NumValues == 1) // check if data is OK
    Reg->WriteString("MHLotto", AnsiString(buff));
    Reg->WriteString("MHmusic", MusicFN); //AnsiString(musicfn));
  }
    Reg->CloseKey();
    delete Reg;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Close1Click(TObject *Sender)
{
 PathName = ""; SpinDate =""; // forget the filename and date
 TForm1::TidyUp(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::TidyUp(TObject *Sender)
{
  for (int row = 0; row < BIGGESTGAMES; row++)
  for (int col = 0; col < BIGGESTDRAWS; col++)
  lotto[col][row] = 0; // results in blank display
  NewConfigData = true;
  TForm1::MakeGrid(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Help1Click(TObject *Sender)
{
 AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Media1Click(TObject *Sender, TMPBtnType Button,
      bool &DoDefault)
{
  Spin1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Music1Click(TObject *Sender)
{

FILE *infile;
//OpenDialog1->FileName = "*.mid";
//OpenDialog1->Filter = "Music files (*.mid)|*.mid|Wave files (*.wav)|*.wav|Videos (*.mpg)|*.mpg|Videos (*.avi)|*.avi|All files (*.*)|*.*";
//OpenDialog1->FilterIndex = 1; // start the dialog showing midi files
//OpenDialog1->Title = "Choose some accompanying music or a video";

 if (OpenDialog1->Execute());
 {
  infile = fopen(OpenDialog1->FileName.c_str(), "rt");
  if (infile)
  {  MusicFN = OpenDialog1->FileName;
 if (access(MusicFN.c_str(), 04) == 0)  // exists and readable
 {
 MediaPlayer1->Enabled = True; MediaPlayer1->Visible = True;
 MediaPlayer1->FileName = MusicFN.c_str();  MediaPlayer1->Open();
 Label5->Caption = MusicFN;
 }
 }
 }
}
//---------------------------------------------------------------------------



void __fastcall TForm1::PowerBall1Click(TObject *Sender)
{
  xdraws = 6; xindep = 1; xrange = 45; xsupp = 0; GameName = "PowerBall";
  PowerBall1->Checked = true; Tattslotto1->Checked = false;
  TForm1::TidyUp(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Tattslotto1Click(TObject *Sender)
{
  xdraws = 6; xindep = 0; xrange = 45; xsupp = 2; GameName = "TattsLotto";
  Tattslotto1->Checked = true; PowerBall1->Checked = false;
  TForm1::TidyUp(Sender);
}
//---------------------------------------------------------------------------







